package com.unitesk.requality.eclipse.handlers.locations;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.ide.IDE;

import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.editors.NodeEditorInput;
import com.unitesk.requality.eclipse.editors.browser.ReqMarker;
import com.unitesk.requality.eclipse.handlers.requirement.OpenRequirementHandler;
import com.unitesk.requality.eclipse.views.RequalityCNF;
import com.unitesk.requality.nodetypes.Location;

public class OpenLocationHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        Location loc = (Location) RequalityCNF.getSelectedNode();
        NodeEditorInput input = new NodeEditorInput(loc.getParent());
        input.setData(loc);
        try {
            IEditorReference eref = Activator.findMarkEditorForDocument(loc
                    .getParent().getQualifiedId());
            if (eref == null) {
                IDE.openEditor(PlatformUI.getWorkbench()
                        .getActiveWorkbenchWindow().getActivePage(), input,
                        ReqMarker.ID);
            } else {
                ((ReqMarker) eref.getEditor(true)).setTargetLocation(loc);
            }
        } catch (PartInitException e) {
            e.printStackTrace();
        }
        OpenRequirementHandler.showProperties();
        return null;
    }

}
