package com.unitesk.requality.eclipse.handlers.requirement;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.editors.browser.AddSelectionToRequirement;
import com.unitesk.requality.eclipse.views.RequalityCNF;
import com.unitesk.requality.nodetypes.Requirement;

public class CreateRequirementHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        TreeNode node = RequalityCNF.getSelectedNode();
        String id = AddSelectionToRequirement.getNextId(node);
        Requirement newReq = (Requirement) node.createChild(id, "Requirement");
        newReq.saveAttributes();
        Activator.getDefault().setActiveNode(newReq, "Requirement");
        return null;
    }

    @Override
    public boolean isEnabled() {
        TreeNode node = RequalityCNF.getSelectedNode();
        if (node == null) {
            return false;
        }
        if (!node.getType().equals("Requirement")) {
            return false;
        }
        return true;
    }

}
